scala.tools.nsc.typechecker.Contexts

# ContextReporter

###
Related Doc: package Contexts

#### abstract class ContextReporter extends Reporter

A reporter for use during type checking. It has multiple modes for handling errors.

The default (immediate mode) is to send the error to the global reporter. When switched into buffering mode via makeBuffering, errors and warnings are buffered and not be reported (there's a special case for ambiguity errors for some reason: those are force to the reporter when context.ambiguousErrors, or else they are buffered -- TODO: can we simplify this?)

When using the type checker after typers, an error results in a TypeError being thrown. TODO: get rid of this mode.

To handle nested contexts, reporters share buffers. TODO: only buffer in BufferingReporter, emit immediately in ImmediateReporter

Source
  Contexts.scala

Linear Supertypes
Reporter, Reporter, AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. ContextReporter
2. Reporter
3. Reporter
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ContextReporter(_errorBuffer: LinkedHashSet[Analyzer.AbsTypeError] = null, _warningBuffer: LinkedHashSet[(Global.Position, String)] = null)

### Type Members

1. #### type Error = Analyzer.AbsTypeError

2. #### class Severity extends AnyRef

   Definition Classes
     Reporter

3. #### type Warning = (Global.Position, String)

### Abstract Value Members

1. #### abstract def handleError(pos: Global.Position, msg: String): Unit

   Attributes
     protected

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Analyzer.ContextReporter to any2stringadd[Analyzer.ContextReporter] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Analyzer.ContextReporter, B)

   Implicit information
     This member is added by an implicit conversion from Analyzer.ContextReporter to ArrowAssoc[Analyzer.ContextReporter] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### lazy val ERROR: Severity

   Definition Classes
     Reporter → Reporter

7. #### object INFO extends Severity

   Definition Classes
     Reporter → Reporter

8. #### object WARNING extends Severity

   Definition Classes
     Reporter → Reporter

9. #### def addDiagString(msg: String)(implicit context: Analyzer.Context): String

   Attributes
     protected

10. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

11. #### var cancelled: Boolean

    Definition Classes
      Reporter

12. #### final def clearAll(): Unit

13. #### final def clearAllErrors(): Unit

14. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate() @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

15. #### def comment(pos: Position, msg: String): Unit

    Definition Classes
      Reporter

16. #### def count(severity: Severity): Int

    Definition Classes
      Reporter → Reporter

17. #### def echo(msg: String): Unit

    For sending a message which should not be labelled as a warning/error, but also shouldn't require -verbose to be visible.

    For sending a message which should not be labelled as a warning/error, but also shouldn't require -verbose to be visible.

    Definition Classes
      Reporter

18. #### def echo(pos: Position, msg: String): Unit

    Definition Classes
      Reporter

19. #### final def emitWarnings(): Unit

20. #### def ensuring(cond: (Analyzer.ContextReporter) ⇒ Boolean, msg: ⇒ Any): Analyzer.ContextReporter

    Implicit information
      This member is added by an implicit conversion from Analyzer.ContextReporter to Ensuring[Analyzer.ContextReporter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### def ensuring(cond: (Analyzer.ContextReporter) ⇒ Boolean): Analyzer.ContextReporter

    Implicit information
      This member is added by an implicit conversion from Analyzer.ContextReporter to Ensuring[Analyzer.ContextReporter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

22. #### def ensuring(cond: Boolean, msg: ⇒ Any): Analyzer.ContextReporter

    Implicit information
      This member is added by an implicit conversion from Analyzer.ContextReporter to Ensuring[Analyzer.ContextReporter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

23. #### def ensuring(cond: Boolean): Analyzer.ContextReporter

    Implicit information
      This member is added by an implicit conversion from Analyzer.ContextReporter to Ensuring[Analyzer.ContextReporter] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

24. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

25. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

26. #### def error(pos: Position, msg: String): Unit

    Definition Classes
      Reporter

27. #### final def errorBuffer: LinkedHashSet[Analyzer.AbsTypeError]

    Attributes
      protected

28. #### def errorCount: Int

    Definition Classes
      Reporter

29. #### final def errors: collection.immutable.Seq[Error]

30. #### final def firstError: Option[Analyzer.AbsTypeError]

31. #### def flush(): Unit

    Definition Classes
      Reporter

32. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Analyzer.ContextReporter to StringFormat[Analyzer.ContextReporter] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

33. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

34. #### def handleSuppressedAmbiguous(err: Analyzer.AbsAmbiguousTypeError): Unit

    Attributes
      protected

35. #### def handleWarning(pos: Global.Position, msg: String): Unit

    Attributes
      protected

36. #### final def hasErrors: Boolean

    Definition Classes
      ContextReporter → Reporter → Reporter

37. #### def hasWarnings: Boolean

    Definition Classes
      Reporter

38. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @IntrinsicCandidate()

39. #### final def info(pos: Position, msg: String, force: Boolean): Unit

    Informational messages.

    Informational messages. If `!force`, they may be suppressed.

    Definition Classes
      Reporter

40. #### final def info0(pos: Global.Position, msg: String, severity: Severity, force: Boolean): Unit

    Attributes
      protected
    Definition Classes
      ContextReporter → Reporter

41. #### def isBuffering: Boolean

42. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

43. #### def isThrowing: Boolean

44. #### def issue(err: Analyzer.AbsTypeError)(implicit context: Analyzer.Context): Unit

45. #### final def issueAmbiguousError(err: Analyzer.AbsAmbiguousTypeError)(implicit context: Analyzer.Context): Unit

    Emit an ambiguous error according to context.ambiguousErrors

    Emit an ambiguous error according to context.ambiguousErrors

    - when true, use global.reporter regardless of whether we're buffering (TODO: can we change this?)
    - else, let this context reporter decide

46. #### def makeBuffering: Analyzer.ContextReporter

47. #### def makeImmediate: Analyzer.ContextReporter

48. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

49. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

50. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @IntrinsicCandidate()
    Note

      not specified by SLS as a member of AnyRef

51. #### def propagateImplicitTypeErrorsTo(target: Analyzer.ContextReporter): Unit

52. #### final def propagatingErrorsTo[T](target: Analyzer.ContextReporter)(expr: ⇒ T): T

    Annotations
      @inline()

53. #### def reportFirstDivergentError(fun: Global.Tree, param: Global.Symbol, paramTp: Global.Type)(implicit context: Analyzer.Context): Unit

54. #### def reset(): Unit

    Definition Classes
      Reporter → Reporter

55. #### def resetCount(severity: Severity): Unit

    Definition Classes
      Reporter → Reporter

56. #### def retainDivergentErrorsExcept(saved: Analyzer.DivergentImplicitTypeError): Unit

57. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

58. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

59. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

60. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

61. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

62. #### def warning(pos: Position, msg: String): Unit

    Definition Classes
      Reporter

63. #### final def warningBuffer: LinkedHashSet[(Global.Position, String)]

    Attributes
      protected

64. #### def warningCount: Int

    Definition Classes
      Reporter

65. #### final def warnings: collection.immutable.Seq[Warning]

66. #### final def withFreshErrorBuffer[T](expr: ⇒ T): T

    Annotations
      @inline()

67. #### def →[B](y: B): (Analyzer.ContextReporter, B)

    Implicit information
      This member is added by an implicit conversion from Analyzer.ContextReporter to ArrowAssoc[Analyzer.ContextReporter] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### def finalize(): Unit

   Called by the garbage collector on the receiver object when there are no more references to the object.

   Called by the garbage collector on the receiver object when there are no more references to the object.

   The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @Deprecated @deprecated @throws( classOf[java.lang.Throwable] )
   Deprecated

     (Since version ) see corresponding Javadoc for more information.

   Note

     not specified by SLS as a member of AnyRef

### Inherited from Reporter

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Analyzer.ContextReporter to any2stringadd[Analyzer.ContextReporter]

### Inherited by implicit conversion StringFormat from Analyzer.ContextReporter to StringFormat[Analyzer.ContextReporter]

### Inherited by implicit conversion Ensuring from Analyzer.ContextReporter to Ensuring[Analyzer.ContextReporter]

### Inherited by implicit conversion ArrowAssoc from Analyzer.ContextReporter to ArrowAssoc[Analyzer.ContextReporter]

### Ungrouped